%% Clear everthing
clear all; clc;
%% NSGA hyperparameters
Options.SaveDir = 'Exemple'; %Save directory
nmbOfIndivs = 100; % Population size
nmbOfGens = 600; % Maximum generation count
pX = 1; % Probality of crossing
pM = 0.1; % Mutation probability
etaX = 1; % Likeness between child and parents
etaM=1; % Likeness between mutated and unmutated children 
%% Population intialization (uniforme distribution)
% Example : uniform distribution
RandParams =  repmat( [1 -5 1], 3, 1) ;
% Bounds of the optimization variable
Ranges = repmat( [-5 5], 3, 1);
%% Launch optimization
[ParGen, ObjVals,ConstrVals, Ranking, SumOfViols, NmbOfFront] = ...
  NSGA_II( nmbOfIndivs, nmbOfGens, @ObjContrNGSA, RandParams, Ranges, ...
  pX, etaX, pM, etaM, Options);
%% Plot final population
figure;
plot(ObjVals(1,:),ObjVals(2,:),'ko')
xlabel("Kursawe function dim=1");
ylabel("Kursawe function dim=2");
%% Objective and constraints functions  
function [ObjVals,ConstrVals]= ObjContrNGSA(Indivs)
    % Evaluate for each individual
    [nmbOfVars nmbOfIndivs] = size( Indivs);
    ObjVals = zeros( 2, nmbOfIndivs);
    ObjVals( 1, :) = sum( -10 * exp( -.2 * ...
        sqrt( Indivs(1:(end -1), :).^2 + Indivs(2:end, :).^2)), 1);
    ObjVals( 2, :) = sum( abs( Indivs).^.8 + 5 * sin( Indivs.^3), 1);
    %No constraints
    ConstrVals=zeros(1,nmbOfIndivs);
end