%% Clear everthing
clear all; clc;
%% Bounds for [a ; b ; c ; d ; n1 ; S1 ; S2]
% Lower bounds 
lb = [ 3e-3 ; 14e-3 ; 6e-3 ; 10e-3 ; 200 ; 0.15e-6 ; 0.15e-6 ]; 
% Upper bounds
ub = [ 30e-3 ; 95e-3 ; 40e-3 ; 80e-3 ; 1200 ; 19e-6 ; 19e-6 ];

%% 3) Optimise with Fmincon (SQP algorithm)
% Init point
x0 = rand(size(lb)).*(ub-lb)+lb ;

% Launch algorithm
options = optimoptions('fmincon','Algorithm','sqp','Display','iter-detailed');  
[xopt,fopt,exitflag] = fmincon(@myfun,x0,[],[],[],[],lb,ub,@mycon,options) ;

%% Exitflag meanings
% 1 <-> convergence (1st order optimality)
% >1 <-> convergence (other criteria)
% 0 <-> max iteration count reached
% >=-1 <-> no convergence 
%% Extraction of objective and constraints
function f = myfun(x)
    f = 0;
    ...
end

function [g,h] = mycon(x)
    g = 0;
    h = 0;
    ...
end
    
    